const Mysql = require("./dal/mysql-base");
const Sqlite3 = require("./dal/sqlite3-base");

module.exports = async function (dbType, config, tableName, showSqlStr) {
  if (
    dbType == "mysql" &&
    typeof config == "object" &&
    config.host &&
    config.user &&
    config.password &&
    config.port &&
    config.database
  ) {
    let isSuccess = await Mysql.testConnect(config);
    if (isSuccess) {
      console.log("connect mysql success.");
      return new Mysql(config, tableName, showSqlStr);
    } else {
      return null;
    }
  } else {
    let isSuccess = await Sqlite3.testConnect(config);
    if (isSuccess) {
      console.log("connect sqlite3 success.");
      return new Sqlite3(config, tableName, showSqlStr);
    } else {
      return null;
    }
  }
};

// config demo

// {
//   "connectionLimit": 10,
//   "host": "substats_mysql",
//   "user": "root",
//   "password": "kZtRazdBsxy3d2zs",
//   "port": 3306,
//   "database": "substats-w3f"
// }
